# code: language=ansible
---
- name: Create traefik folders.
  ansible.builtin.file:
    path: "{{ item }}"
    state: directory
    owner: "{{ ansible_ssh_user }}"
    group: "{{ ansible_ssh_user }}"
    mode: "755"
  with_items:
    - "{{ traefik_home }}"
    - "{{ traefik_home }}/data"
    - "{{ traefik_home }}/data/acme"

- name: Copy traefik files for {{ traefik_container_name }}
  ansible.builtin.template:
    src: "{{ item.from }}"
    dest: "{{ traefik_home }}/{{ item.to }}"
    owner: "{{ ansible_ssh_user }}"
    group: "{{ ansible_ssh_user }}"
    mode: "0644"
  with_items:
    - from: "docker-compose.yaml.j2"
      to: "docker-compose.yaml"
    - from: "traefik.yml.j2"
      to: "data/traefik.yml"
    - from: ".env.j2"
      to: ".env"
  register: configs
  notify: "restart"

- name: Copy config.yml if "hosts_to_proxy" is defined.
  ansible.builtin.template:
    src: "config.yml.j2"
    dest: "{{ traefik_home }}/data/config.yml"
    owner: "{{ ansible_ssh_user }}"
    group: "{{ ansible_ssh_user }}"
    mode: "0644"
  when: hosts_to_proxy is defined
  notify: "restart"

- name: Pull image of {{ traefik_image }}
  community.docker.docker_image:
    name: "{{ traefik_image }}:{{ traefik_ver }}"
    source: pull
  notify: "restart"

- name: Get info on container {{ traefik_container_name }}
  community.docker.docker_container_info:
    name: "{{ traefik_container_name }}"
  register: traefik_container
  changed_when: traefik_container.exists == False
  no_log: true
  notify: "restart"
